#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>


#define BUFSIZE 1024

// Sendet eine Datei
//  fd: Socket
//  file: Datei
long SockSendFile(int fd, char *filename)
{
  int file;
  long size, isize;
  char buf[BUFSIZE];
  int i;

  if ((size = filelen(filename)) <= 0) {
    return -1;
  }
  if ((file = open(filename, O_RDONLY)) < 0) {
    return -1;
  }
  // Senden der Dateigre
  if (write(fd, (char *) &size, sizeof(size)) != sizeof(size)) {
    return -1;
  }
  // Datentransfer
  for (isize = 0; isize < size; isize += i) {
    if ((i = read(file, buf, BUFSIZE)) < 0) { // Lese aus Datei
      return -1;
    }
    if (write(fd, buf, i) != i) {             // Sende
      return -1;
    }
  }
  close(file);
  return size;
}

// Empfngt eine Datei
//  fd: Socket
//  file: Datei
long SockRecvFile(int fd, char *filename)
{
  int file;
  long size, isize;
  char buf[BUFSIZE];
  int i, r;

  remove(filename);
  if ((file = creat(filename, 0644)) < 0) {
    return -1;
  }
  // Empfangen der Dateigre
  i = 0;
  while (i < sizeof(size)) {
    i += (r = read(fd, ((char *) &size) + i, sizeof(size) - i));
    if (r <= 0) {
      return -1;
    }
  }
  // Datentransfer
  for (isize = 0; isize < size; isize += i) {
    if ((i = read(fd, buf, (BUFSIZE > (size - isize)) ? (size - isize) : BUFSIZE)) <= 0) {
      return -1;
    }
    write(file, buf, i);
  }
  close(file);
  return size;
}
