#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

/* Wie kann man sicher berprfen, ob die Gegenseite die ist fr die
   sie sich ausgibt? Mit dieser Methode:

   1.) Beide Seiten erzeugen einen Zufallsstring
   2.) gegenseitiges zusenden dieses Strings
   3.) an diesen String den Authstring anhngen
   4.) davon die MD5Summe bilden
   5.) empfangen des Zufallsstring von der Gegenseite
   6.) an diesen String den Authstring anhngen
   7.) davon die MD5Summe bilden
   8.) Prfsummen austauschen
   9.) Prfen, ob die von der Gegenseite erzeugte Prfsumme mit der
       eigenen bereinstimmt, wenn Ja alles OK

   Das gute daran, der Authstring wird nicht bertragen, also kann
   diesen auch nicht geklaut werden. Da man aus der MD5Sums den
   Originalstring nicht mehr bilden kann, kann diese ohne bedenken
   bermittelt werden...

   Genau das tut diese Funktion:

   if (SockMD5Auth(socket des gegenber, authstring) == 1) {
     Alles OK
   }

*/


removetmpfiles(char *f1, char *f2)
{
  char s[512];
  FILE *f;

  if ((f = fopen(f1, "r+")) != NULL) {
    fwrite(s, 512, 1, f);
    fflush(f);
    fclose(f);
  }
  remove(f1);
  if ((f = fopen(f2, "r+")) != NULL) {
    fwrite(s, 512, 1, f);
    fflush(f);
    fclose(f);
  }
  remove(f2);
}


int SockMD5Auth(int fd, char *pwd)
{
  FILE *random, *f;
  unsigned int seed;
  int i;
  int sizerstr0, sizerstr1;
  char rstr0[256], rstr1[256];
  char rstr0sum[35], rstr1sum[35];
  char tempfile[255], tempfile2[255], command[512];

  // open /dev/urandom
  if ((random = fopen("/dev/urandom", "r")) == NULL) {
    random = fopen("/dev/random", "r");
  }
  // Init C-Rand.
  fread(&seed, 1, 4, random);
  srand(seed);
  // Size fr Auth-String
  sizerstr0 = 64 + (int) (60.0 * rand() / (RAND_MAX + 1.0));
  // Die erstern 32 Byte mit RAND fllen...
  for (i = 0; i < 32; i++) {
    rstr0[i] = (int) (256.0 * rand() / (RAND_MAX + 1.0));
  }
  // Den Rest von urandom
  fread(rstr0 + 32, sizerstr0 - 32, 1, random);
  // keine Nullen im String, Null am Ende
  for (i = 0; i < sizerstr0; i++) {
    if (rstr0[i] == 0) {
      rstr0[i] = 54;
    }
  }
  rstr0[sizerstr0] = 0;
  // Namen fr Tempfiles
  sprintf(tempfile, "/tmp/.blacky.SockMD5Auth.%d.img", getpid());
  sprintf(tempfile2, "/tmp/.blacky.SockMD5Auth.%d.sum", getpid());
  // Lokale Prfsumme
  // schreiben der Daten in Datei
  if ((f = fopen(tempfile, "w")) == NULL) {
    removetmpfiles(tempfile, tempfile2);
    return 0;
  }
  fwrite(rstr0, sizerstr0, 1, f);
  fwrite(pwd, strlen(pwd), 1, f);
  fflush(f);
  fclose(f);
  // errechnen der Prfsumme
  sprintf(command, "md5sum %s > %s", tempfile, tempfile2);
  system(command);
  // Lesen der Prfsumme
  if ((f = fopen(tempfile2, "r")) == NULL) {
    removetmpfiles(tempfile, tempfile2);
    return 0;
  }
  fread(rstr0sum, 32, 1, f);
  rstr0sum[32] = 0;
  fclose(f);
  // Sende den Zufallsstring
  SockSendString(fd, rstr0);

  // Gegenber
  // Empfangen des Zufallsstrings
  sizerstr1 = SockRecvString(fd, rstr1);
  // schreiben der Daten in Datei
  if ((f = fopen(tempfile, "w")) == NULL) {
    removetmpfiles(tempfile, tempfile2);
    return 0;
  }
  fwrite(rstr1, sizerstr1, 1, f);
  fwrite(pwd, strlen(pwd), 1, f);
  fflush(f);
  fclose(f);
  // errechnen der Prfsumme
  sprintf(command, "md5sum %s > %s", tempfile, tempfile2);
  system(command);
  // Lesen der Prfsumme
  if ((f = fopen(tempfile2, "r")) == NULL) {
    removetmpfiles(tempfile, tempfile2);
    return 0;
  }
  fread(rstr1sum, 32, 1, f);
  rstr1sum[32] = 0;
  fclose(f);
  // Senden der aus dem Zufallsstring ermittelte Summe
  SockSendString(fd, rstr1sum);

  // Empfangen der aus dem Zufallsstrings ermittelte Summe
  SockRecvString(fd, rstr1sum);
  // Vergleichen
  if (strcmp(rstr0sum, rstr1sum) == 0) {
    // OK
    SockSendString(fd, "OK");
    SockRecvString(fd, rstr0sum);
    if (strcmp(rstr0sum, "OK") == 0) {
      removetmpfiles(tempfile, tempfile2);
      return 1;
    } else {
      removetmpfiles(tempfile, tempfile2);
      return 0;
    }
  } else {
    // ERROR
    SockSendString(fd, "ERROR");
    removetmpfiles(tempfile, tempfile2);
    return 0;
  }
}
