/*
    Dies ist meine zentrale Lib.

    Diese Function liet einen String von der Eingabe und bietet
    Eingabeedtitig funktionen.

    Copyright (C) 1998,2001 Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/
*/

#include <curses.h>
#include <stdio.h>


/* keypad(stdscr, TRUE); .. es macht mehr Spass.*/

/* Liest einen String von der Eingabe, und bietet dabei eine Einfache
Editing-Funktion.

str: Der String, wenn in dieser Variable etwas vorhanden ist, wird es
mit der UP-Taste geladen (zurckholen der letzten Eingabe), wenn die
Parameter al ungleich NULL ist, wird dies gleich am Anfang getan
(Einen Wert vorgeben).

x und y sind die Koordinaten auf dem Bildschirm, an welchen die
Eingabe stattfindet.

*/

void editstr(str, x, y, al)
  char *str;
  int x, y;
  int al;
{
  char st[400], buf[500];
  int pos, i, il, glen0 = 0, glen1 = 0;

  if (al != 0) {
    strcpy(st, str);
    pos = strlen(st);
  } else {
    st[0] = 0;
    pos = 0;
  }
  mvaddstr(x, y, st);
  move(x, y + pos);
  refresh();
  for (i = strlen(st); i < 400; i++) {
    st[i] = 0;
  }
  while(1) {
    i = getch();
    switch (i) {
      // Mit UP kann man die alte Eingabe wiederherstellen
    case 259:
      strcpy(st, str);
      //  pos = strlen(st);
      break;
	  
      /* Abrechen (ESC wenn string gelscht ist) oder Lschen (ESC wenn strimg 
	 da ist) */
    case 27:
      if (st[0] == 0) {
	return;
      } else {
	st[0] = 0;
	pos = 0;
      }
      break;
      /* <- */
    case 260:
      if (pos > 0) {
	pos--;
      }
      break;
      /* -> */
    case 261:
      if (pos < strlen(st)) {
	pos++;
      }
      break;
      /* HOME */
      /*	  case 72: */
    case 262:
    case 1:
      pos = 0;
      break;
      /* END */
      /* case 70: */
    case 5:
    case 360:
      pos = strlen(st);
      break;
      /* ENTER - Engabe Speichern und Beenden */
    case 13:
    case 343:
      strcpy(str, st);
      return;
      break;
      /* Delete */
    case 330: /* Del */
    case 4:   /* C-d */
      i = strlen(st);
      if (pos < i) {
	if (pos == il - 1) {
	  st[i - 1] = 0;
	} else {
	  for (il = pos; il < i; il++)
	    st[il] = st[il + 1];
	}
      }
      break;
      /* Bakspace */
    case 263:
      i = strlen(st);
      if (pos != 0) {
	if (pos == i) {
	  st[i - 1] = 0;
	  pos--;
	} else {
	  for (il = (pos - 1); il < i; il++) {
	    st[il] = st[il + 1];
	  }
	  pos--;
	}
      }
      break;
      /* Tausche Buchstaben - C-t */
    case 20:
      if (pos != 0) {
	if (pos == strlen(st)) {
	  //	  (char) i = st[pos - 1];
	  i = (char) st[pos - 1];
	  st[pos - 1] = st[pos - 2];
	  st[pos - 2] = (char) i;
	  break;
	}
	/* else */
	//	(char) i = st[pos];
	i = (char) st[pos];
	st[pos] = st[pos - 1];
	st[pos - 1] = (char) i;
      }
      break;
      /* Alles hinter dem cursor Lschen - C-k */
    case 11:
      il = strlen(st);
      if (pos == (il - 1)) {
	break;
      }
      for (i = pos; i < (il - 1); i++) {
	st[i] = 0;
      }
      break;
      /* Alles vor dem cursor Lschen - C-u */
    case 21:
      i = strlen(st);
      if (pos != 0) {
	if (pos == i) {
	  for (il = 0; il < i; il++) {
	    st[il] = 0;
	  }
	  pos = 0;
	} else {
	  for (il = 0; (il + pos) < i; il++) {
	    st[il] = st[il + pos];
	  }
	  for (il = (i - pos); il < i; il++) {
	    st[il] = 0;
	  }
	  pos = 0;
	}
      }
      break;
      /* Andere Taste */
    default:
      if ((i > 31) && (i < 256)) {
	if (pos == strlen(st)) {
	  il = strlen(st);
	  st[il] = i;
	  st[il + 1] = 0;
	  pos++;
	} else {
	  for (il = strlen(st); il > pos; il--) {
	    st[il] = st[il - 1];
	  }
	  st[strlen(st) + 1] = 0;
	  st[pos] = i;
	  pos++;
	}
      }
      break;
    } /* ENDE CASE */
    
    glen1 = glen0;
    sprintf(buf, "``%s''", st);
    if (st[0] == 0) {
      sprintf(buf, "``%s'' (ESC - Abrechen)", st);
    }
    glen0 = strlen(buf);
    if (glen0 < glen1) {
      for (i = (glen0); i < ((glen1 - glen0) + (glen0)); i++) {
	if (buf[i] != ' ') {
	  buf[i] = ' ';
	}
      }
      buf[i] = 0;
    }
    mvaddstr(x, y, buf);
    move(x, y + pos + 2); /* +2 wegen `` */
    refresh();
  } /* while(1) */

  /* y ->
     x von oben
     Bei Null Beginnend!! */
}
