/*
    Dies ist meine zentrale Lib.

    Diese Funktion ersetzt Abkrzungen in einem String durch die in
    der Blacky-Daten-Bank (~/bdb/ak.bdb) angegebenen String.

    Copyright (C) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
              hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/

*/


#include "hofmeier.h"
#include <stdio.h>


getak(r, ak)
  char *r, *ak;
{
  FILE *f;
  char str[255], akstr[200], es[4];
  int i;
  unsigned char trz = 0;

  es[0] = 0x10;
  es[1] = 0x0f;
  es[2] = 0x11;
  es[3] = 0x00;

  sprintf(str, "%s/bdb/ak.bdb", getenv("HOME"));
  f = fopen(str, "r");
  if (f == NULL)
    {
      fprintf(stderr, "Can not read the AK file!\n");
      return;
    }
  dosread(f, str);
  trz = bdb_head(str);
  if (trz == 0)
    {
      fprintf(stderr, "AK file is not an Blacky Daten Bank!\n");
      return;
    }
  dosread(f, str);
  dosread(f, str);

  r[0] = 0;

  do
    {
      dosread(f, str);
      bdb_conv(str, 0, trz);
      if (str[0] == 0x0f)
	{
	  GetDatenSatz(akstr, str, 1);
	  if (0 == strcmp(akstr, ak))
	    {
	      GetDatenSatz(akstr, str, 2);
	      strcpy(r, akstr);
	      return;
	    }
	}
    }
  while ((0 != strncmp(str, es, 3)) && (str[0] != 0));
  fclose(f);
}
