/*
    Dies ist meine zentrale Lib.

    Diese Function gibt den Vollstndigen namen eine Zeichens zurck.
    z.B. "'" --> "single quote".

    Copyright (C) 1998,2001 Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
              hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/
*/


#include "hofmeier.h"


/* Gibt den Namen eines Zeichens zurck.
   Bekommt das Zeichen in c und Schreibt den Namen in
   st welcher ein char[] ist! */
getcharname(char *st, unsigned char c)
{
  switch (c) {
  case 0:
    strcpy(st, "nul - Nil (Null)");
    break;
    
  case 1:
    strcpy(st, "SOH - START OF HEADING (Kopfzeilenbeginn)");
    break;
    
  case 2:
    strcpy(st, "STX - START OF TEXT (Textanfangszeichen)");
    break;
    
  case 3:
    strcpy(st, "ETX - END OF TEXT (Textendzeichen)");
    break;
    
  case 4:
    strcpy(st, "EOT - END OF TRANSMISSION (Ende der bertragung)");
    break;
    
  case 5:
    strcpy(st, "ENQ - ENQUIRY (Aufforderung zur Datenbertragung)");
    break;
    
  case 6:
    strcpy(st, "ACK - ACKNOWLEDGE (Positive Rckmeldung)");
    break;
    
  case 7:
    strcpy(st, "BEL - Bell (Klingelzeichen)");
    break;
    
  case 8:
    strcpy(st, "BS  - BACKSPACE (Rckschritt)");
    break;
    
  case 9:
    strcpy(st, "HT  - HORIZONTAL TABULATION (Horizontaler Tabulator)");
    break;
    
  case 10:
    strcpy(st, "LF  - LINE FEED (Zeilenvorschub)");
    break;
    
  case 11:
    strcpy(st, "VT  - VERTICAL TABULATION (Vertikaler Tabulator)");
    break; 
    
  case 12:
    strcpy(st, "FF  - FORM FEED (Formularvorschub)");
    break;
    
  case 13:
    strcpy(st, "CR  - CARRIAGE RETURN (Wagenrcklauf)");
    break;
    
  case 14:
    strcpy(st, "SO  - SHIFT-OUT (Dauerumschaltung)");
    break;
    
  case 15:
    strcpy(st, "SI  - SHIFT-IN (Rckschaltung)");
    break;
    
  case 16:
    strcpy(st, "DLE - DATA LINK ESCAPE (bertragungsumschaltung)");
    break;
    
  case 17:
    strcpy(st, "DC1 - DEVICE CONTROL 1");
    break;
    
  case 18:
    strcpy(st, "DC2 - DEVICE CONTROL 2");
    break;
    
  case 19:
    strcpy(st, "DC3 - DEVICE CONTROL 3");
    break;
    
  case 20:
    strcpy(st, "DC4 - DEVICE CONTROL 4");
    break;
    
  case 21:
    strcpy(st, "NAK - NEGATIVE ACKNOWLEDGE (Negative Rckmeldung)");
    break;
    
  case 22:
    strcpy(st, "SYN - SYNCHRONOUS IDLE (Syncronisirung)");
    break;
    
  case 23:
    strcpy(st, "ETB - END OF TRANSMISSION BLOCK");
    break;
    
  case 24:
    strcpy(st, "CAN - CANCEL (Ungltig)");
    break;
    
  case 25:
    strcpy(st, "EM  - END OF MEDIUM (Ende der Aufzeichnung)");
    break;
    
  case 26:
    strcpy(st, "EOF - END OF FILE / SUB - SUBSTITUTE (Substitution)");
    break;
    
  case 27:
    strcpy(st, "ESC - ESCAPE (Umschaltung / Fliehen)");
    break;
    
  case 28:
    strcpy(st, "FS  - FILE SEPERATOR (Hauptgruppentrennzeichen)");
    break;
    
  case 29:
    strcpy(st, "GS  - GROUP SEPERATOR (Gruppentrennzeichen)");
    break;
    
  case 30:
    strcpy(st, "RS  - RECORD SEPERATOR (Untergruppentrennzeichen)");
    break;
    
  case 31:
    strcpy(st, "US  - UNIT SEPERATOR (Teilgruppentrennzeichen)");
    break;
    
  case 32:
    strcpy(st, "SP  - SPACE (Lerzeichen)");
    break;
    
  case '!': /* 33 */
    strcpy(st, "Ausrufezeichen");
    
  case '~': /* 127 */
    strcpy(st, "tilde / DEL - DELETE (Lschen)");
    break;
    
  case '\'': /* 39 */
    strcpy(st, "single quote, Apostroph");
    break;
    
  case '"': /* 34 */
    strcpy(st, "(double) quote, Anfrungszeichen");
    break;
    
  case '`': /* 96 */
    strcpy(st, "backtick, Gravis");
    break;
    
  case '': /* 176 */
    strcpy(st, "degree - grad");
    break;
    
  case '^': /* 94 */
    strcpy(st, "circumflex, Aufwrtspfeil, Zirkumflex");
    break;
    
  case '@': /* 64 */
    strcpy(st, "at - Affenschwans, kommerzielles \"\" \"`a\"");
    break;
    
  case '&': /* 38 */
    strcpy(st, "ampersand - kaufmnnisches/kommerzielles Und");
    break;
    
  case '$': /* 36 */
    strcpy(st, "dollar, Whrungszeichen");
    break;
    
  case '': /* 167 */
    strcpy(st, "paragraph");
    break;
    
  case '#': /* 35 */
    strcpy(st, "nummernzeichen - lattenkreutz");
    break;
    
  case '(': /* 40 */
  case ')': /* 41 */
    strcpy(st, "parenthesis - runde klammer");
    break;
    
  case '[': /* 91 */
  case ']': /* 93 */
    strcpy(st, "brackets - eckige klammer");
    break;
    
  case '{': /* 124 */
  case '}': /* 125 */
    strcpy(st, "braces - geschweifte klammer");
    break;
    
  case '>': /* 62 */
    strcpy(st, "grer als");
    break;
    
  case '<': /* 60 */
    strcpy(st, "kleiner als");
    break;
    
  case ',': /* 44 */
    strcpy(st, "komma");
    break;
    
  case ';': /* 59 */
    strcpy(st, "semikolon");
    break;
    
  case '/': /* 47 */
    strcpy(st, "slash, Schrgstrich");
    break;
    
  case '\\': /* 92 */
    strcpy(st, "backslash, inverser Schrgstrich");
    break;
    
  case '': /* 181 */
    strcpy(st, "micro");
    break;
    
  case '|': /* 124 */
    strcpy(st, "pipe, Senkrechter Strich");
    break;
    
  case '*': /* 42 */
    strcpy(st, "asterisk - stern");
    break;
    
  case '_': /* 95 */
    strcpy(st, "unterstrich");
    break;


  default:
    st[0] = 0;
    break;
  } /* switch() */
}
